﻿@echo off
chcp 65001

set "bitpath=C:\Program Files (x86)\Blue Iris Tools"
set "logfile=%bitpath%\log\dewpoint.log"
cd "%bitpath%\addons\Dewpoint"

rem get temperature (fahrenheit)
	rem parse number only
		type "%bitpath%\txt\temperature.txt" | tr -dc '0-9.' > tmpfile-tf.txt
	rem set tempf variable from file
		set /p tempf=<tmpfile-tf.txt

rem get temperature (celsius)
	rem convert temp fahrenheit to celsius
		echo scale=1; (%tempf%-32)*.5556 | bc -l > tmpfile-tc.txt
	rem set tempc variable from file
		set /p tempc=<tmpfile-tc.txt

rem get relative humidity
	rem parse number only
		type "%bitpath%\txt\humidity.txt" | tr -dc '0-9.' > tmpfile-rh.txt
	rem set rh variable from file
		set /p rh=<tmpfile-rh.txt

rem get dewpoint (celsius)
	rem calculate dewpoint
		echo 243.04*(l(%rh%/100)+((17.625*%tempc%)/(243.04+%tempc%)))/(17.625-l(%rh%/100)-((17.625*%tempc%)/(243.04+%tempc%))) | bc -l > tmpfile-dpc.txt
	rem set dpc variable from file
		set /p dpc=<tmpfile-dpc.txt

rem get dewpoint (fahrenheit)
	rem convert dewpoint from celsius to fahrenheit
		echo (%dpc%*1.8)+32 | bc -l | sed -e "s/\(\.[0-9]\).*/\1°F/g" | tr -d '\n' > "%bitpath%\txt\dewpoint.txt"
		set /p dpf=<"%bitpath%\txt\dewpoint.txt"

rem deal with log file 
	rem if the log file exists and is 1MB or larger rotate it
		if exist "%logfile%" (
			set "logfile=%bitpath%\log\dewpoint.log"
			for %%A in ("%logfile%") do set filesize=%%~zA
			set maxfilesize=1000000
			set /a B=(%filesize%)
			if %filesize% GEQ %maxfilesize% (ren "%logfile%" dewpoint.%date:~-4,4%%date:~-7,2%%date:~-10,2%%time:~-11,2%%time:~-8,2%%time:~-5,2%.log)
				)
	rem if the log file doesn't exist create it with headers
		if not exist "%bitpath%\log\dewpoint.log"^
			(echo date/time,tempf,tempc,humidity,dpc,dpf >> "%bitpath%\log\dewpoint.log")
	rem write data to log file
		echo | set /p="%date% %time%," >> "%logfile%"
		echo | set /p="%tempf%," >> "%logfile%"	
		echo | set /p="%tempc%," >> "%logfile%"
		echo | set /p="%rh%," >> "%logfile%"
		echo | set /p="%dpc%," >> "%logfile%"
		echo | set /p="%dpf%" >> "%logfile%"
		echo. >> "%logfile%"
 
rem write dewpoint to everything file
	echo. | tr "" "\n" >> "%bitpath%\txt\everything.txt"
	echo | set /p="Dewpoint: " >> "%bitpath%\txt\everything.txt"
	echo (%dpc%*1.8)+32 | bc -l | sed -e "s/\(\.[0-9]\).*/\1°F/g" | tr -d '\n' >> "%bitpath%\txt\everything.txt"

rem Cleanup 
	rem delete tmp files
		del tmpfile*
	rem set varibles to NULL
		set "tempf="
		set "tempc="
		set "rh="
		set "dpc="
		set "dpf="

